! detection des structure dans une image binarisee par une fonction
! recursive.

	module detection

contains

	subroutine detect(a,nx,ny,xg,yg,surf,nff)

	use belong

	implicit none

	real xg(:),yg(:)
	double precision g(3)
	integer k,res,i,j,surf(:),nff,nx,ny
	integer, dimension (nx,ny) :: a

	xg=0.; yg=0.; surf=0

	k=1
	do j=1,ny
	 do i=1,nx
	  if (a(i,j) == 4) then
	   g=0.
	   res=belong_to(a,i,j,g)
	   if (nint(g(3)) > 20) then ! on n'enregistre pas le bruit
	    xg(k)=g(1)/g(3)
	    yg(k)=g(2)/g(3)
	    surf(k)=nint(g(3))
	    k=k+1 
	   endif
	  endif
	 enddo
	enddo

 	print*,'nb de structures',k-1
	nff=k-1

	end subroutine

	end module
